import 'package:meta/meta.dart';

import 'store.dart';

class AsynchronousAction<Model> {
  final String name;
  final ExecuteAsynchronousAction<Model> execute;
  const AsynchronousAction({
    @required this.execute,
    @required this.name,
  });
}

typedef Future<void> ExecuteAsynchronousAction<Model>(
  Getter<Model> model,
  Dispatcher dispatch,
);

typedef Model Getter<Model>();
