import 'package:flutter/widgets.dart';
import 'package:provider/provider.dart';

typedef MvuSelector<Model, T> = T Function(Model model);

typedef MvuValueBuilder<T> = Widget Function(BuildContext context, T value);

class MvuBuilder<Model, T> extends StatelessWidget {
  final MvuSelector<Model, T> selector;
  final MvuValueBuilder<T> builder;
  const MvuBuilder({
    Key key,
    @required this.selector,
    @required this.builder,
  })  : assert(selector != null),
        assert(builder != null),
        super(key: key);

  @override
  Widget build(BuildContext context) {
    return Selector<Model, T>(
      selector: (context, model) => selector(model),
      builder: (context, value, _) => builder(context, value),
    );
  }
}
